using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_LoginLogs
    /// </summary>
    public partial class T_Sys_LoginLogs
    {
        public T_Sys_LoginLogs()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_LoginLogs");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Sys_LoginLogs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_LoginLogs(");
            strSql.Append("F_LoginName,F_LoginId,F_Result,F_LoginIP,F_Hostname,F_LoginDate,F_Remark,F_State,F_LoginOutDate)");
            strSql.Append(" values (");
            strSql.Append("@F_LoginName,@F_LoginId,@F_Result,@F_LoginIP,@F_Hostname,@F_LoginDate,@F_Remark,@F_State,@F_LoginOutDate)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_LoginName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_LoginId", SqlDbType.Int,4),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_LoginIP", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Hostname", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_LoginDate", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,300),
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_LoginOutDate", SqlDbType.DateTime)};
            parameters[0].Value = model.F_LoginName;
            parameters[1].Value = model.F_LoginId;
            parameters[2].Value = model.F_Result;
            parameters[3].Value = model.F_LoginIP;
            parameters[4].Value = model.F_Hostname;
            parameters[5].Value = model.F_LoginDate;
            parameters[6].Value = model.F_Remark;
            parameters[7].Value = model.F_State;
            parameters[8].Value = model.F_LoginOutDate;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_LoginLogs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_LoginLogs set ");
            strSql.Append("F_LoginName=@F_LoginName,");
            strSql.Append("F_LoginId=@F_LoginId,");
            strSql.Append("F_Result=@F_Result,");
            strSql.Append("F_LoginIP=@F_LoginIP,");
            strSql.Append("F_Hostname=@F_Hostname,");
            strSql.Append("F_LoginDate=@F_LoginDate,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_LoginOutDate=@F_LoginOutDate");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_LoginName", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_LoginId", SqlDbType.Int,4),
                    new SqlParameter("@F_Result", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_LoginIP", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Hostname", SqlDbType.NVarChar,100),
                    new SqlParameter("@F_LoginDate", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NVarChar,300),
                    new SqlParameter("@F_State", SqlDbType.SmallInt,2),
                    new SqlParameter("@F_LoginOutDate", SqlDbType.DateTime),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_LoginName;
            parameters[1].Value = model.F_LoginId;
            parameters[2].Value = model.F_Result;
            parameters[3].Value = model.F_LoginIP;
            parameters[4].Value = model.F_Hostname;
            parameters[5].Value = model.F_LoginDate;
            parameters[6].Value = model.F_Remark;
            parameters[7].Value = model.F_State;
            parameters[8].Value = model.F_LoginOutDate;
            parameters[9].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_LoginLogs ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_LoginLogs ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_LoginLogs GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_LoginName,F_LoginId,F_Result,F_LoginIP,F_Hostname,F_LoginDate,F_Remark,F_State,F_LoginOutDate from T_Sys_LoginLogs ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            Model.T_Sys_LoginLogs model = new Model.T_Sys_LoginLogs();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_LoginLogs DataRowToModel(DataRow row)
        {
            Model.T_Sys_LoginLogs model = new Model.T_Sys_LoginLogs();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_LoginName"] != null)
                {
                    model.F_LoginName = row["F_LoginName"].ToString();
                }
                if (row["F_LoginId"] != null && row["F_LoginId"].ToString() != "")
                {
                    model.F_LoginId = int.Parse(row["F_LoginId"].ToString());
                }
                if (row["F_Result"] != null)
                {
                    model.F_Result = row["F_Result"].ToString();
                }
                if (row["F_LoginIP"] != null)
                {
                    model.F_LoginIP = row["F_LoginIP"].ToString();
                }
                if (row["F_Hostname"] != null)
                {
                    model.F_Hostname = row["F_Hostname"].ToString();
                }
                if (row["F_LoginDate"] != null && row["F_LoginDate"].ToString() != "")
                {
                    model.F_LoginDate = DateTime.Parse(row["F_LoginDate"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_LoginOutDate"] != null && row["F_LoginOutDate"].ToString() != "")
                {
                    model.F_LoginOutDate = DateTime.Parse(row["F_LoginOutDate"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_LoginName,F_LoginId,F_Result,F_LoginIP,F_Hostname,F_LoginDate,F_Remark,F_State,F_LoginOutDate ");
            strSql.Append(" FROM T_Sys_LoginLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_LoginName,F_LoginId,F_Result,F_LoginIP,F_Hostname,F_LoginDate,F_Remark,F_State,F_LoginOutDate ");
            strSql.Append(" FROM T_Sys_LoginLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_LoginLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_LoginLogs T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
